# EVM Integrations

The `EthereumProvider` defined in Tomo Connect SDK contains all the necessary functions to interact with EVM chains. Core functions are:

### requestAddresses

Implemented `eth_requestAccounts`

```javascript
public async requestAddresses()
```

### getAddresses

Implemented `eth_accounts`

```javascript
public async getAddresses()
```

### signMessage

Implemented `personal_sign`

```javascript
public async signMessage(msg: string, address: string)
```

### signTypedData

Implemented `eth_signTypedData_v4`

```javascript
public async signTypedData(address: string, msg: string)
```

### sendTransaction

Implemented `eth_sendTransaction`

```javascript
export interface EvmTxParams {
  from: string,
  to: string,
  value: string,
  gasPrice?: string,
  gasLimit?: string,
  maxFeePerGas?: string,
  maxPriorityFeePerGas?: string,
  data?: string,
}

public async sendTransaction(params: EvmTxParams)
```

### sendRawTransaction

Implemented `eth_sendRawTransaction`

```javascript
public async sendRawTransaction(signedTx: string) 
```

### swithChain

Implemented `wallet_switchEthereumChain`

```javascript
public async swithChain(chainId: string)
```

### recoverMessageAddress

Implemented `personal_ecRecover`

```javascript
public async recoverMessageAddress(message: string, signature: string)
```

Also EthereumProvider is a provider compatible with EIP 1193. It can be integrated with third-party libraries like viem, ethers, just like window\.ethereum.

```
// Integrated with viem
const client = createWalletClient({
  chain: mainnet,
  transport: custom(tomoSDK.ethereumProvider)
})
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tomo.inc/tomo-sdk/tomo-web-sdk/wallet-providers/evm-integrations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
